# $Id: observablehttpserver.py 3919 2010-08-31 06:51:38Z place $
# $URL: https://svn.non-gnu.uvt.nl/uvt-dev/tags/sources/meresco/bzv-9.4.0/src/observablehttpserver.py $
from meresco.components.http import ObservableHttpServer

from weightless._httpserver import HttpHandler
from weightless._acceptor import Acceptor
from syslog import syslog
from traceback import format_exc 


class BZVHttpHandler(HttpHandler):
    def __init__(self, *args, **kwargs):
        if 'logger' in kwargs:
            self.logger = kwargs['logger'] 
            del kwargs['logger']
        HttpHandler.__init__(self, *args, **kwargs)
     
    def _writeResponse(self):
        __callstack_var_httpserver__ = self
 
        response = ''
        try:
            response = HttpHandler._writeResponse(self)
        except:
#           errorString = format_exc()
#           for line in errorString.split("\n"):
#               self.logger.error(line)
            self.logger.error(format_exc()) 
        return response
 
    def suspend(self):
        reactor = self._reactor
        reactor.removeWriter(self._sok)
        return reactor

    def resume(self):
        self._reactor.addWriter(self._sok, self._writeResponse, prio=self._prio)

class BZVObservableHttpServer(ObservableHttpServer):
    def __init__(self, *args, **kwargs):
        if 'infra' in kwargs:
            self.infra = kwargs['infra'] 
            del kwargs['infra']
            self.infra.logging.debug('Starting httpserver logging')
            self.logger = self.infra.logging.getLogger('meresco.httpserver')
            self.logger.debug('Starting httpserver logger')   
        ObservableHttpServer.__init__(self, *args, **kwargs)
    
    def startServer(self):
        Acceptor(self._reactor, self._port, 
                 lambda sok: BZVHttpHandler(self._reactor, sok, self._connect, self._timeout, 4096, prio=self._prio, logger=self.logger), 
                 prio=self._prio, sok=self._sok)
        self._started = True
